#include <bits/stdc++.h>
using namespace std;

const vector<long long> IMPOSSIBLE = {-1};

map< pair<long long, long long>, vector<long long> > memo;

vector<long long> delitele(long long n) {
    vector<long long> answer;
    for (long long d=1; d*d<=n; ++d) if (n%d == 0) {
        answer.push_back(d);
        if (d*d < n) answer.push_back(n/d);
    }
    return answer;
}

void update(vector<long long> &answer, const vector<long long> &option) {
    if (option.size() > answer.size()) answer = option;
}

vector<long long> solve(long long sum_remaining, long long last_chosen) {
    vector<long long> answer;
    for (long long m=2; m*last_chosen<=sum_remaining; ++m) {
        long long curr = m*last_chosen;
        long long left = sum_remaining - curr;
        if (left == 0) {
            update( answer, vector<long long>(1,curr) );
            continue;
        }
        if (left < 2*curr) continue;
        vector<long long> option = solve(left, curr);
        if (option.empty()) continue;
        option.insert( option.begin(), curr );
        update( answer, option );
    }
    return answer;
}

int main() {
    long long n;
    cin >> n;
    vector<long long> answer = solve(n,1);
    cout << answer.size() << endl;
    for (unsigned i=0; i<answer.size(); ++i) cout << answer[i] << (i+1 == answer.size() ? '\n' : ' ');
}
