#include <bits/stdc++.h>
using namespace std;

unordered_map<long long, int> memo;

vector<long long> delitele(long long n) {
    vector<long long> answer;
    for (long long d=1; d*d<=n; ++d) if (n%d == 0) {
        answer.push_back(d);
        if (d*d < n) answer.push_back(n/d);
    }
    return answer;
}

int najlepsie_t(long long n) {
    if (memo.count(n)) return memo[n];
    int &answer = memo[n];
    answer = 1;
    for (long long d : delitele(n)) if (3 <= d && d < n) answer = max(answer, 1+najlepsie_t(d-1));
    return answer;
}

vector<long long> zostroj_najlepsie(long long n) {
    if (memo[n] == 1) return vector<long long>(1,n);
    for (long long d : delitele(n)) if (3 <= d && d < n) {
        if (memo[d-1]+1 == memo[n]) {
            vector<long long> answer = zostroj_najlepsie(d-1);
            answer.insert( answer.begin(), 1 );
            for (auto &x : answer) x *= n/d;
            return answer;
        }
    }
    return vector<long long>(0,-47);
}

int main() {
    long long n;
    cin >> n;
    cout << najlepsie_t(n) << endl;
    vector<long long> answer = zostroj_najlepsie(n);
    for (unsigned i=0; i<answer.size(); ++i) cout << answer[i] << (i+1 == answer.size() ? '\n' : ' ');
}
